/**
 * [15821] Team CODA
 * File Manager
 * By Sang Kil Cha, Jaeyoon Chong, Anoop Jaishankar
 */

#ifndef __FINE_FM_H__
#define __FINE_FM_H__

#define M_FIND_ICON          "finefm-find-icon"
#define M_NEW_ICON           "finefm-new-icon"
#define M_MOVE_ICON          "finefm-move-icon"
#define M_INFO_ICON          "finefm-info-icon"
#define M_DEL_ICON           "finefm-del-icon"

#define HILDON_RESPONSE_FOLDER_CREATED 54321

struct _HildonFileSelectionPrivate {
    GtkWidget *scroll_dir;
    GtkWidget *scroll_list;
    GtkWidget *scroll_thumb;
    GtkWidget *dir_tree;
    GtkWidget *view[4]; /* List, thumbnail, empty, repair */
    int cur_view;
    GtkWidget *hpaned;

    GtkTreeModel *main_model;
    GtkTreeModel *sort_model;   /* HildonFileSystemModel doesn't implement */
    GtkTreeModel *dir_sort;     /* GtkTreeSortable */

    GtkTreeModel *dir_filter;
    GtkTreeModel *view_filter;

    GtkTreeRowReference *current_folder;
    GtkWidget *view_selector;
    GtkFileFilter *filter;

    HildonFileSelectionMode mode;       /* User requested mode. Actual
                                           mode is either this or an empty
                                           view containing a message */
    guint banner_timeout_id;
    guint banner_close_timeout_id;
    guint content_pane_changed_id;
    guint delayed_select_id;
    GtkWidget *update_banner;
    gboolean content_pane_last_used;

    gboolean column_headers_visible;

    /* This is set when widget is shown and content pane
       should have focus, but there is nothing yet. We use this to move focus when
       there is some content */
    gboolean force_content_pane;

    /* Set to FALSE when a folder loading starts. If user moves the cursor this
       is set to TRUE. So if it's still FALSE when folder loading is finished,
       we can move the cursor where we want. */
    gboolean user_touched;
    /* Set if user have scrolled bar to specific position. This causes
       automatic scrolling to cursor be disabled when the loading is done */
    gboolean user_scrolled;

    /* Properties */

    HildonFileSelectionVisibleColumns visible_columns;
    gboolean drag_enabled;
    gboolean local_only;

    gboolean show_hidden;
    gboolean show_upnp;
    gboolean currently_dragging;
    GtkFilePath *safe_folder;

    gchar **drag_data_uris;

    gchar *cursor_goal_uri;
};

#endif
